#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "fitsio.h"
#include "fitsdebug.h"


void fd_err_message(int status) {

  /* Return a text message to the screen with the */
  /* appropriate error message                    */

  char message[30];

  if (status < 1000) {
    fits_get_errstatus(status, message);
    printf("Error (cfitsio,%d) : %s\n", status, message);
  } else {
    switch (status) {
    case FD_STAT_SUPERSEDE: 
      printf("Error (fd,%d) : Incorrect supersede flag value\n", status);
      break;
    case FD_STAT_FLUSH: 
      printf("Error (fd,%d) : Incorrect flush flag value\n", status);
      break;
    case FD_STAT_FILE_NOT_OPEN: 
      printf("Error (fd,%d) : Fits file is not open\n", status);
      break;
    case FD_STAT_TABLE_TYPE:
      printf("Error (fd,%d) : Incorrect table type\n", status);
      break;
    case FD_STAT_NO_INT:
      printf("Error (fd,%d) : \"int\" type definition not accepted\n",status);
      break;
    case FD_STAT_NO_TYPE:
      printf("Error (fd,%d) : Type definition not accepted\n", status);
      break;
    case FD_STAT_NCOL:
      printf("Error (fd,%d) : Insufficient # of arg to fd_create_file\n", 
	     status);
      break;
    default:   
      printf("Error (fd,%d) : Unknown error [should never happen]\n", status);
      break;
    }
  }
}


