atomdb=getenv('ATOMDB')
if (n_elements(line) eq 0) then $
  read_linelist,atomdb+'/apec_line.fits',line,t1,n1,l1
if (n_elements(rsline) eq 0) then $
  read_linelist,'RS93_line.fits',rsline,t2,n2,l2
if (n_elements(coco) eq 0) then $
  read_coco,atomdb+'/apec_coco.fits',coco,t3,n3,l3
if (n_elements(rscoco) eq 0) then $
  read_coco,'RS93_coco.fits',rscoco,t4,n4,l4

!xtitle = 'Temperature (K)'
!ytitle = 'Emissivity (erg cm!E3!N s!E-1!N)'

set_plot,'ps'
device,filename='TotalPower.ps'

plot_oo,t1,l1+l3,thick=3,yrange=[1.e-23,1.e-21]
oplot,t1,l1,linestyle=1,thick=3
oplot,t3,l3,linestyle=2,thick=3

oplot,t2,l2+l4,thick=1
oplot,t2,l2,thick=1,linestyle=1
oplot,t4,l4,thick=1,linestyle=2

;legend,['APEC','RS93'],linestyle=[0,1],box=0,/top,/right;
legend,['APEC: Thick','RS93: Thin','Total','Line','Continuum'],$
  linestyle=[-1,-1,0,1,2],psym=[-3,-3,-3,-3,-3],box=0,/top,/right

device,/close
