%
%
%
%
%
%
% Global setup
%
% 1) Load apec models
%variable am_types;
%if (__is_initialized(&am_types) == 0) {load_apec();}

%
% 2) load apec continuum model
%if (Utils->member("ap",get_defined_models()) == NULL) {
%   () = sherpa_eval("apec[ap]");
%   () = sherpa_eval("ap integrate on");
%   () = set_frozen("ap");
%   AM_load_continuum("EXHYDRA_apec_continuum.txt");
%   AM_continuum_only();
%   () = evalfile("fit_lines.sl");
%   fit_exhydra_lines();
%}

%
% 3) set some global variables
variable _hegfwhm_ = 0.012;
variable _megfwhm_ = 0.023;
variable _fp_ = NULL;
%
%
define get_yn_reply() {
   
   variable usage = "get_yn_reply(question, [default=Y])";
   variable question, default, default_str, ans;

   if (Utils->check_nargs(_NARGS,1,2) == 0) {
      message(usage);
      return;
   }

   if (_NARGS == 1) {
      (question) = ();
      default = "Y";
   } else {
      (question,default) = ();
   }


   if (0 == strcmp(default,"Y") or 0 == strcmp(default,"y")) {
      default = 1;
      default_str = "[Y/n]";
   } else if (0 == strcmp(default,"N") or 0 == strcmp(default,"n")) {
      default = 0;
      default_str = "[y/N]";
   } else {
      default = 1;
      default_str = "[Y/n]";
   }

   () = printf("\n");
   () = printf("%s %s : ",question,default_str);
   if (-1 == fgets(&ans,stdin)) {
     error("Error: unable to open standard input.");
   }
   ans = strtrim_end(ans); 

   if (ans == "") {
      return default; 
   } else if (0 == strcmp(ans,"Y") or 0 == strcmp(ans,"y")) {
      return 1;
   } else if (0 == strcmp(ans,"N") or 0 == strcmp(ans,"n")) {
      return 0;
   } else {
      return 0;
   }

    
}

%
%
define fit_line(l,err) {

   variable dataset, datasets = [3,4,9,10];
   variable cmnd_str,counts;
   variable _fwhm_, _i_ = 0.0;
   variable gpos, gfwhm, fit_result, cov_result;
   variable p,pm,pp,f,fm,fp,a,am,ap;
   variable lmin,lmax;
   % set continuum model
   
   if (_fp_ != NULL) {
      () = fprintf(_fp_,"%g %g",l,err);
   } else {
      () = printf("%g %g",l,err);
   }
   foreach (datasets) {
      dataset = ();
      _i_--;
      if (dataset < 5) {
	 _fwhm_ = _hegfwhm_;
      } else {
	 _fwhm_ = _megfwhm_;
      }
      lmin = l - 2*_fwhm_;
      lmax = l + 2*_fwhm_;

      % set continuum model
      () = set_ignore_all(dataset);
      () = set_notice(dataset,lmin,lmax);
      % check is there is any data to fit
      counts = get_dcounts_sum(dataset,[lmin,lmax]);
      if (counts != NULL) {
         if (counts.value != 0) {
            () = set_source_expr(dataset,"ap + ngauss1d[g]");
	    % set parameter values
	    gpos = get_par("g.pos");
	    gpos.value = l;
	    gpos.frozen = 1;
	    () = set_par(gpos);
	    gfwhm = get_par("g.fwhm");
	    gfwhm.value = _fwhm_;
	    gfwhm.frozen = 1;
	    () = set_par(gfwhm);
	    %
	    fit_result = run_fit(dataset);
	    %
	    gpos.frozen = 0;
	    () = set_par(gpos);
	    %
	    fit_result = run_fit(dataset);
	    %
	    cov_result = run_cov();
	    
	    cmnd_str = sprintf("lplot 1 fit %d",dataset);
		() = sherpa_eval(cmnd_str);
	    () = set_source_expr(dataset," ");
	    cmnd_str = sprintf("erase g");
	    () = sherpa_eval(cmnd_str);
	    
	    if (0 == get_yn_reply("Satisfied with fit?","Y")) {
	       message("will save dummy info to file, handfit later");
	       if (_fp_ != NULL) {
		  () = fprintf(_fp_," %g %g %g %g %g %g %g %g %g",_i_,_i_,_i_,_i_,_i_,_i_,_i_,_i_,_i_);
	       } else {
		  () = printf(" %g %g %g %g %g %g %g %g %g",_i_,_i_,_i_,_i_,_i_,_i_,_i_,_i_,_i_);
	       }
	    } else {
	       p  = cov_result[0].val;
	       pm = cov_result[0].vlo;
	       pp = cov_result[0].vhi;
	       %f  = cov_result[0].val;
	       %fm = cov_result[0].vlo;
	       %fp = cov_result[0].vhi;
	       f = _fwhm_;
	       fm = -0.0001;
	       fp =  0.0001;
	       a  = cov_result[1].val;
	       am = cov_result[1].vlo;
	       ap = cov_result[1].vhi;
	       
	       if (_fp_ != NULL) {
		  () = fprintf(_fp_," %g %g %g %g %g %g %g %g %g",p,pm,pp,f,fm,fp,a,am,ap);
	       } else {
		  () = printf(" %g %g %g %g %g %g %g %g %g",p,pm,pp,f,fm,fp,a,am,ap);
	       }
	    }
	 } else {
	    if (_fp_ != NULL) {
	       () = fprintf(_fp_," %g %g %g %g %g %g %g %g %g",_i_,_i_,_i_,_i_,_i_,_i_,_i_,_i_,_i_);
	    } else {
	       () = printf(" %g %g %g %g %g %g %g %g %g",_i_,_i_,_i_,_i_,_i_,_i_,_i_,_i_,_i_);
	    }
	 }
       } else {
         if (_fp_ != NULL) {
	    () = fprintf(_fp_," %g %g %g %g %g %g %g %g %g",_i_,_i_,_i_,_i_,_i_,_i_,_i_,_i_,_i_);
	 } else {
	    () = printf(" %g %g %g %g %g %g %g %g %g",_i_,_i_,_i_,_i_,_i_,_i_,_i_,_i_,_i_);
	 }
      }
    }
    if (_fp_ != NULL) {
	() = fprintf(_fp_,"\n");
    } else {
	() = printf("\n");
    }

}

define avg_wvl(val,weight) {

   variable n = length(val);
   variable sum_weight = sum(weight);
   variable _weight = weight/sum_weight;
   variable _val = val * _weight;
   
   return sum(_val);

}


define fit_exhydra_lines () {


   _fp_ = fopen("line-centroid-fits-second.fixed-fwhm.txt","w");
   if (_fp_ == NULL) {
      error("Could not open file for writing");
   }


   variable line = struct {wvl_, err_, wvl, err, em};
   variable line1 = @line;
   line1.wvl_ = [1.778044,1.783469];
   line1.err_ = [0.000009,0.000009];
   line1.em   = [2.43e-17,1.22e-17];
   %
   variable line2 = @line;
   line2.wvl_ = [1.850399,1.855412,1.859517];
   line2.err_ = [0.000600,0.000600,0.000600];
   line2.em   = [4.57e-17,8.39e-18,8.01e-18];
   %
   variable line3 = @line;
   line3.wvl_ = [4.727366,4.732779];
   line3.err_ = [0.000020,0.000020];
   line3.em   = [1.96e-17,9.78e-18];
   %
   variable line4a = @line;
   line4a.wvl_ = [5.038726];
   line4a.err_ = [0.002000];
   line4a.em   = [3.43e-17];
   %
   variable line4b = @line;
   line4b.wvl_ = [5.063144,5.066492];
   line4b.err_ = [0.002000,0.002000];
   line4b.em   = [3.07e-18,4.45e-18];
   %
   variable line5 = @line;
   line5.wvl_ = [6.180438,6.185849];
   line5.err_ = [0.000030,0.000030];
   line5.em   = [5.19e-17,2.59e-17];
   %
   variable line6 = @line;
   line6.wvl_ = [6.647947];
   line6.err_ = [0.002000];
   line6.em   = [8.77e-17];
   %
   variable line7 = @line;
   line7.wvl_ = [6.684988,6.688187];
   line7.err_ = [0.002000,0.002000];
   line7.em   = [4.40e-18,1.20e-17];
   %
   variable line8 = @line;
   line8.wvl_ = [7.985700,7.996000];
   line8.err_ = [0.000200,0.000200];
   line8.em   = [1.35e-17,6.90e-18];
   %
   variable line9 = @line;
   line9.wvl_ = [8.419209,8.424620];
   line9.err_ = [0.000040,0.000040];
   line9.em   = [6.89e-17,3.45e-17];
   %
   variable line10 = @line;
   line10.wvl_ = [9.168750];
   line10.err_ = [0.003000];
   line10.em   = [1.10e-16];
   %
   variable line11 = @line;
   line11.wvl_ = [9.228167,9.231208];
   line11.err_ = [0.003000,0.003000];
   line11.em   = [2.23e-18,1.60e-17];
   %
   variable line12 = @line;
   line12.wvl_ = [10.238492,10.239582];
   line12.err_ = [0.000050,0.000050];
   line12.em   = [3.42e-17,1.71e-17];
   %
   variable line13 = @line;
   line13.wvl_ = [10.619000];
   line13.err_ = [0.020000];
   line13.em   = [1.00e-16];
   %
   variable line14 = @line;
   line14.wvl_ = [10.663000];
   line14.err_ = [0.005000];
   line14.em   = [5.26e-17];
   %
   variable line15 = @line;
   line15.wvl_ = [11.176000];
   line15.err_ = [0.002000];
   line15.em   = [1.22e-16];
   %
   variable line16 = @line;
   line16.wvl_ = [11.423000,11.427000,11.432000];
   line16.err_ = [0.004000,0.005000,0.003000];
   line16.em   = [3.86e-17,5.93e-17,6.52e-17];
   %
   variable line17 = @line;
   line17.wvl_ = [11.736000];
   line17.err_ = [0.004000];
   line17.em   = [2.41e-16];
   %
   variable line19 = @line;
   line19.wvl_ = [12.132085];
   line19.err_ = [0.000060];
   line19.em   = [2.72e-16];
   %
   variable line20 = @line;
   line20.wvl_ = [13.447307];
   line20.err_ = [0.004000];
   line20.em   = [4.06e-16];
   %
   variable line21 = @line;
   line21.wvl_ = [14.208000,14.208000];
   line21.err_ = [0.003000,0.003000];
   line21.em   = [2.21e-16,4.05e-16];
   %
   variable line22 = @line;
   line22.wvl_ = [15.014000];
   line22.err_ = [0.001000];
   line22.em   = [1.98e-15];
   %
   variable line23 = @line;
   line23.wvl_ = [15.261000];
   line23.err_ = [0.002000];
   line23.em   = [5.60e-16];
   %
   variable line24 = @line;
   line24.wvl_ = [16.004000,16.005520,16.006659];
   line24.err_ = [0.002000,0.000080,0.000080];
   line24.em   = [1.94e-16,2.84e-16,1.42e-16];
   %
   variable line25 = @line;
   line25.wvl_ = [16.780001];
   line25.err_ = [0.002000];
   line25.em   = [9.24e-16];
   %
   variable line26a = @line;
   line26a.wvl_ = [17.051001];
   line26a.err_ = [0.001000];
   line26a.em   = [1.10e-15];
   %
   variable line26b = @line;
   line26b.wvl_ = [17.096001];
   line26b.err_ = [0.001000];
   line26b.em   = [1.04e-15];
   %
   variable line27 = @line;
   line27.wvl_ = [18.967110];
   line27.err_ = [0.000090];
   line27.em   = [2.47e-15];
   %
   variable line28 = @line;
   line28.wvl_ = [21.601503];
   line28.err_ = [0.007000];
   line28.em   = [3.50e-15];
   %
   variable line29 = @line;
   line29.wvl_ = [21.803638];
   line29.err_ = [0.007000];
   line29.em   = [5.62e-16];
   %

   variable lines = [line1 ,line2 ,line3 ,line4a,line4b ,line5 ,line6 ,line7 ,line8 ,line9 ,line10,
		     line11,line12,line13,line14,line15,line16,line17,line19,line20,
		     line21,line22,line23,line24,line25,line26a,line26b,line27,line28,line29];
   
   message("hello hello");
   variable ln;
   foreach (lines) {
      ln = ();
      ln.wvl = avg_wvl(ln.wvl_,ln.em); 
      ln.err = avg_wvl(ln.err_,ln.em); 
   }

   foreach (lines) {
      ln = ();
      fit_line(ln.wvl,ln.err);
   }


   () = fclose(_fp_);



}



%variable ln_,i=1,j,pref;
%variable  source3 = "source 3 = ap ";
%variable  source4 = "source 4 = ap ";
%variable  source9 = "source 9 = ap ";
%variable  source10 = "source 10 = ap ", tmp;
%foreach(lines) {
%   ln = ();
%   if (i == 1) {
%      pref = ln.wvl_[0];
%vmessage("pref = %f",pref);
%   }
%   j=1;
%   foreach(ln.wvl_) {
%      ln_ = ();
%      vmessage("ngauss1d[g%d_%d_3](0.012)",i,j);
%      vmessage("freeze g%d_%d_3.fwhm",i,j);
%      vmessage("ngauss1d[g%d_%d_4](0.012)",i,j);
%      vmessage("freeze g%d_%d_4.fwhm",i,j);
%      vmessage("ngauss1d[g%d_%d_9](0.023)",i,j);
%      vmessage("freeze g%d_%d_9.fwhm",i,j);
%      vmessage("ngauss1d[g%d_%d_10](0.023)",i,j);
%      vmessage("freeze g%d_%d_10.fwhm",i,j);
%      vmessage("g%d_%d_4.ampl => g%d_%d_3.ampl ",i,j,i,j);
%      vmessage("g%d_%d_9.ampl => g%d_%d_3.ampl ",i,j,i,j);
%      vmessage("g%d_%d_10.ampl => g%d_%d_3.ampl ",i,j,i,j);
%      if (i != 1) {
%         vmessage("g%d_%d_3.pos  => g1_1_3.pos + %f ",i,j,ln_-pref);
%         vmessage("g%d_%d_4.pos  => g1_1_4.pos + %f ",i,j,ln_-pref);
%         vmessage("g%d_%d_9.pos  => g1_1_9.pos + %f ",i,j,ln_-pref);
%         vmessage("g%d_%d_10.pos => g1_1_10.pos + %f ",i,j,ln_-pref);
%      }
%source3 = source3+sprintf("+ g%d_%d_3 ",i, j);
%source4 = source4+sprintf("+ g%d_%d_4 ",i, j);
%source9 = source9+sprintf("+ g%d_%d_9 ",i, j);
%source10 = source10+sprintf("+ g%d_%d_10 ",i, j);
%      j++;
%   }
%   i++;
%}
%print(source3);
%print(source4);
%print(source9);
%print(source10);
%
%
%foreach(lines) {
%   ln = ();
%   j=length(ln.wvl_);
%   for (i = 0; i < j; i++) {
%      vmessage("%g & %f & %f & %f & %f\\ ",ln.em[i],ln.wvl_[i],ln.err_[i],ln.wvl,ln.err);
% }}
