define load_plasma_line() { % Possibly a file header

   variable header, i, filename;
   variable line;
   
   if ((_NARGS != 0) and (_NARGS != 1)) {
      usage("line = load_plasma_line([\"plasma_file_prefix\"])");
      return;
   }
   
   if (_NARGS == 1) {
      header = ();
   } else {
      header = getenv("ATOMDB");
      if (header == NULL) {
	 verror("ATOMDB apparently not installed; ATOMDB undefined.");
      } 
      header = header+"/apec";
   }
   
   line = Assoc_Type[];
   variable first = readfile(header+"_line.fits");
   for (i=2;i<length(first.kT)+2;i++) {
      filename = sprintf("%s_line.fits[%d][cols Lambda, Epsilon, Element, Ion, UpperLev, LowerLev]",header,i+1);
      line[string(i-1)] = readfile(filename);
   }
   line["0"] = first;

   return line;
}
 
define load_plasma_coco() { % Possibly a file header

   variable header, i, filename;
   variable coco;
   
   if ((_NARGS != 0) and (_NARGS != 1)) {
      usage("coco = load_plasma_coco([\"plasma_file_prefix\"])");
      return;
   }
   
   if (_NARGS == 1) {
      header = ();
   } else {
      header = getenv("ATOMDB");
      if (header == NULL) {
	 verror("ATOMDB apparently not installed; ATOMDB undefined.");
      } 
      header = header+"/apec";
   }
   
   coco = Assoc_Type[];
   variable first = readfile(header+"_coco.fits");
   for (i=2;i<length(first.kT)+2;i++) {
      filename = sprintf("%s_coco.fits[%d][cols Z, rmJ, N_Cont, E_Cont, Continuum, N_Pseudo, E_Pseudo, Pseudo",header,i+1);
      coco[string(i-1)] = readfile(filename);
   }
   coco["0"] = first;
   return coco;
}

define load_plasma() { % Possibly a file header

   variable header;
   variable line, coco;
   
   if ((_NARGS != 0) and (_NARGS != 1)) {
      usage("(line, coco) = load_plasma([\"plasma_file_prefix\"])");
      return;
   }
   
   if (_NARGS == 1) {
      header = ();
      line = load_plasma_line(header);
      coco = load_plasma_coco(header);
   } else {
      line = load_plasma_line();
      coco = load_plasma_coco();
   }

   return line, coco;
}
