%
%
%
%
%
%
% Ronnie Hoogerwerf, SAO, 01/07/2004
%
use_namespace("LF");


define read_ionbal () {

   %
   % Now read ionization balance
   %
   variable file;
   variable z, iz;

   switch (_NARGS) 
   { case 0 : file = LF->ionbalfile; }
   { case 1 : file = (); }
   { message("Usage: LF->read_ion_bal([filename]);");
     _pop_n(_NARGS);
     return NULL; }

   file = LF_IO->replace_envs(file);

   variable old_caseinsen = Global->varmm.caseinsen;
   Global->varmm.caseinsen = 1;
   LF->ionbal = readfile(file);
   Global->varmm.caseinsen = old_caseinsen;
   if (LF->ionbal == NULL) {
      vmessage("read_ion_bal: Error reading file %s",file);
   }
   
   %
   %  Now calculate the index.
   %
   z = LF->ionbal.z_element[0,*];
   LF->ionbal_index = Integer_Type [length(z)];
   LF->ionbal_index[0] = 0;
   
   for (iz=1; iz<length(z);iz++) {
      LF->ionbal_index[iz] = LF->ionbal_index[iz-1] + z[iz-1] + 1;
   }

   return 0;

}

define get_ionbal() {


   variable T = NULL, elem = NULL, ion = NULL;

   switch (_NARGS) 
   { case 1 : T = (); }
   { case 2 : (T, elem) = (); }
   { case 3 : (T, elem, ion) = (); }
   { message("Usage: LF->get_ionbal(T [, elem [, ion]])");
     _pop_n(_NARGS); return NULL; }

   variable iT = LF_Math->indx(T,LF->ionbal.temperature);
   if (iT < 0) return NULL;

   if (elem == NULL) {
      return LF->ionbal.x_ionpop[iT,*];
   } else if (ion == NULL) {
      return LF->ionbal.x_ionpop[iT,[LF->ionbal_index[elem-1]:LF->ionbal_index[elem]-1]];
   } else {
      return LF->ionbal.x_ionpop[iT,LF->ionbal_index[elem-1]+ion-1];
   }



}
