%
%
%
% 
% Ronnie Hoogerwerf, SAO, 01/07/2004
%

define plotlinefree(dataset,lmin,lmax,linefree) {

   %
   % Plot spectrum and linefree regions contained in <linefree>
   % for wavelengths lmin < lambda [A] < lmax
   %

   variable data, axes, inl, maxdata, cmnd_str, yline;

   () = set_ignore_all(dataset);
   () = set_notice_all(dataset);
   data = get_data(dataset);
   axes = get_axes(dataset);
   inl  = where(axes.lo >= lmin and axes.hi <= lmax);
   data = data[inl];
   maxdata = max(data)/get_exptime(dataset)/(axes.hi[0]-axes.lo[0]);

   cmnd_str = sprintf("lplot 1 data %d",dataset);
   () = sherpa_eval(cmnd_str);
   
   cmnd_str = sprintf("D 1 limits %f %f %f %f",lmin, lmax, -0.1*maxdata, 1.1*maxdata);
   () = chips_eval(cmnd_str);
   
   yline = -0.05*maxdata;
   variable tmp;
   foreach (linefree) {
      tmp = ();
      cmnd_str = sprintf("D 1 line %f %f %f %f",tmp.start,yline,tmp.end,yline);
      () = chips_eval(cmnd_str);
   }
   () = chips_eval(cmnd_str);

   %
   % Give REDRAW command to sherpa to finialize plot.
   %
   cmnd_str = sprintf("redraw");
   () = chips_eval(cmnd_str);




}
