C
C***********************************************
C
	SUBROUTINE INTERPOL_HUNTD(IC,N,X,Y,M,U,F)
C
C	Subroutine that hunts for the value of 
C	U by disecting the X-interval
C	Numerical recipes page 90
C***********************************************
C
        IMPLICIT REAL (A-H,O-Z)
	DIMENSION X(1),Y(1),U(1),F(1)
	REAL*8 Z,GRAD,DF
	LOGICAL INC
	INC=X(N).GT.X(1)
C       
	IF(INC) THEN
	   IF(U(1).LT.X(1).OR.U(M).GT.X(N)) GO TO 20
	ELSE
	   IF(U(1).GT.X(1).OR.U(M).LT.X(N)) GO TO 20
	END IF
	GO TO 30
 20	WRITE(6,1000)IC,U(1),U(M),X(1),X(N)
 1000	FORMAT(5X,'Checkpoint #',i3/
     .		5X,'Array ',1pe9.2,'-',1pe9.2,' is out of range of the'/
     .	       11X,1PE9.2,'-',1PE9.2,' array')
	STOP
   30	CONTINUE
C       
	DO I=1,M
	   Z=U(I)
C       
	   JL=0
	   JU=N+1
 10	   IF(JU-JL.GT.1) THEN
	      JM=(JU+JL)/2
	      IF((Z.GT.X(JM)).EQV.INC) THEN
		 JL=JM
	      ELSE
		 JU=JM
	      END IF
	      GO TO 10
	   END IF
C       
C------	Z is sandwiched between JL and JU ------
C
	   IF(X(JL).GT.0..AND.X(JU).GT.0.) THEN
	      IF(Y(JL).GT.0..AND.Y(JU).GT.0.) THEN
		 GRAD=(LOG10(Y(JU))-LOG10(Y(JL)))/
     .		      (LOG10(X(JU))-LOG10(X(JL)))
		DF=GRAD*(LOG10(Z)-LOG10(X(JL)))
		F(I)=10**(LOG10(Y(JL))+DF)
		GO TO 40
	     ELSE
		F(I)=Y(JL)+(Y(JU)-Y(JL))*((Z-X(JL))/(X(JU)-X(JL)))
		GO TO 40
	     END IF
	  ELSE
	     F(I)=Y(JL)+(Y(JU)-Y(JL))*((Z-X(JL))/(X(JU)-X(JL)))
	  ENDIF
 40	  CONTINUE
	END DO
C       
	RETURN
	END

