      subroutine init_output(OutFile,CoolingType,Tion,Telec,Tsw, 
     $     usedust,Porosity,Years,MaxFluenc,AbundType,Perstep,Tend,
     $     Pressure, Emis_lines, atom_lines, ion_lines, numlines)

      implicit none

      integer MAXLINES, LUN
      parameter(MAXLINES=2000,LUN=10)

      character*128 OutFile
      
      integer CoolingType, UseDust, AbundType
      real Tion, Telec, Tsw, Perstep, Tend, MaxFluenc
      real Porosity, Years, Pressure
      
      real Emis_lines(MAXLINES)
      integer atom_lines(MAXLINES), ion_lines(MAXLINES), numlines

      open(unit=LUN,file=OutFile,status='NEW')

      if (CoolingType.eq.0) write(LUN,*) '0  Isothermal'
      if (CoolingType.eq.1) write(LUN,*) '1  Isobaric'
      if (CoolingType.eq.2) write(LUN,*) '2  Isochoric'
      if (CoolingType.eq.3) write(LUN,*) '3  Isoswitch'
      if (AbundType.eq.1) write(LUN,*) '1  Anders & Grevesse'
      if (AbundType.eq.2) write(LUN,*) '2  Depleted'
      if (AbundType.eq.3) write(LUN,*) '3  Allen'
      if (AbundType.eq.4) write(LUN,*) '4  Grevesse & Anders'
      
      write(LUN,*) 'Tion, Telec, Tend, dT = ',Tion,Telec,Tend,Perstep
      write(LUN,*) 'Dust, Porosity, MaxFluence = ',
     $     usedust, porosity, MaxFluenc
      write(LUN,*) 'Pressure, Tsw, Years = ',Pressure, Tsw, Years

      write(LUN,*) 'Fluence  Age      T_elec   DenE     TotCool',
     $     '  Ion1     Ion2     Ion3     Ion4'
      return
      end


      subroutine close_output(wisconsin)

      implicit none

      integer LUN
      parameter(LUN=10)

      integer wisconsin

      close(unit=LUN)
      if (wisconsin.eq.1) call close_wisc

      return
      end

      subroutine output(fluenc, time, T, dene, totcool, wisconsin,
     $     numlines, atom_index, ion_index)

      implicit none

      include 'jr_common.inc'

      integer LUN,MAXLINES
      parameter(LUN=10,MAXLINES=2000)

      real fluenc, time, T, dene, totcool, chi
      integer j, wisconsin
      
      integer numlines, atom_index(MAXLINES), ion_index(MAXLINES)

      chi = 2.09090909

      if (numlines .gt. 20) then
         write(*,*) 'output: Rewrite output routine for > 20 lines'
      end if

      if (numlines .eq. 1)
     $     write(LUN,1001) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 2)
     $     write(LUN,1002) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 3)
     $     write(LUN,1003) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 4)
     $     write(LUN,1004) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 5)
     $     write(LUN,1005) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 6)
     $     write(LUN,1006) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 7)
     $     write(LUN,1007) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 8)
     $     write(LUN,1008) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 9)
     $     write(LUN,1009) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 10)
     $     write(LUN,1010) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 11)
     $     write(LUN,1011) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 12)
     $     write(LUN,1012) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 13)
     $     write(LUN,1013) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 14)
     $     write(LUN,1014) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 15)
     $     write(LUN,1015) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 16)
     $     write(LUN,1016) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 17)
     $     write(LUN,1017) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 18)
     $     write(LUN,1018) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 19)
     $     write(LUN,1019) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
      if (numlines .eq. 20)
     $     write(LUN,1020) fluenc, time/secyr, T, dene, totcool,
     $     (pwr(atom_index(j),ion_index(j)),j=1,numlines)
         
      if (wisconsin.eq.1) call output_wisc(fluenc, dene, chi)

 1001 FORMAT(1pe8.2,4e9.2, 1e9.2)
 1002 FORMAT(1pe8.2,4e9.2, 2e9.2)
 1003 FORMAT(1pe8.2,4e9.2, 3e9.2)
 1004 FORMAT(1pe8.2,4e9.2, 4e9.2)
 1005 FORMAT(1pe8.2,4e9.2, 5e9.2)
 1006 FORMAT(1pe8.2,4e9.2, 6e9.2)
 1007 FORMAT(1pe8.2,4e9.2, 7e9.2)
 1008 FORMAT(1pe8.2,4e9.2, 8e9.2)
 1009 FORMAT(1pe8.2,4e9.2, 9e9.2)
 1010 FORMAT(1pe8.2,4e9.2, 10e9.2)
 1011 FORMAT(1pe8.2,4e9.2, 11e9.2)
 1012 FORMAT(1pe8.2,4e9.2, 12e9.2)
 1013 FORMAT(1pe8.2,4e9.2, 13e9.2)
 1014 FORMAT(1pe8.2,4e9.2, 14e9.2)
 1015 FORMAT(1pe8.2,4e9.2, 15e9.2)
 1016 FORMAT(1pe8.2,4e9.2, 16e9.2)
 1017 FORMAT(1pe8.2,4e9.2, 17e9.2)
 1018 FORMAT(1pe8.2,4e9.2, 18e9.2)
 1019 FORMAT(1pe8.2,4e9.2, 19e9.2)
 1020 FORMAT(1pe8.2,4e9.2, 20e9.2)

      return
      end
