c	block data init
c	include 'evolve.h'
c	data nj/1,2,6,7,8,10,12,14,16,18,20,26,28/
c	end



      subroutine rdtable(icflag)
      include 'modevolve.h'
      parameter (nion=30,ntemp=41,ntemp1=11)
      integer icflag,izero(num)
C
C  read tables of ionization and recombination rates vs T
C  also cooling and charge exchange rates.
C  from 1984 Raymond & Smith code
C
C  7/31/86  Richard J. Edgar
C
C  8/2/88: modified by rje to make reading charge exchange tables optional
C	and take log10 of the rates
C
C.................................................
C   inputs:
C	icflag      i	reading options:
C			0 = neither cool nor charge exchange (cx)
C			1 = cool but no cx
C			2 = cx but no cool
C			3 = both cool and cx
C	index(num)  i	array of 1's (to select element) or 0's
C
C   outputs:
C	index(num)  i	array of pointers to neutral species
C	temp(41)    r	log(10) temperatures
C	rion(41,N)  r	ionization rate coefficients
C	rrec(41,N)  r	recombination rate coefficients
C	cool(41,N)  r	cooling rate per ion (or dummy if icflag=0)
C	cxhr(11,N)  r	charge exchange recomb w/ H
C	cxher(11,N) r	charge exchange recomb w/ He
C	cxhi(11,7)  r	charge exchange ioniz. w/ H for ions in..
C	iH(8)       i	pointers (like index()) to cxhi ions.
C	cxhei(11,7) r	charge exchange ioniz. w/ He for ions in ..
C	iHe(8)      i	pointers to cxhei ions.
C        (note that iH and iHe are terminated with zeroes)
C
C	Here N represents the number of ions to be used.  If all
C	available species are selected, N=181.  Unless you elect not
C	to read the charge exchange tables, it is mandatory
C	to select H and He, so that the first 5 ions are HI, HII,
C	HeI, HeII, and HeIII.  This is done even if index(1 and 2)
C	are not set to 1 by the caller.
C......................................................

      logical cx,cf
      character*1 junk
c     data nj/1,2,6,7,8,10,12,14,16,18,20,26,28/
C  'live' ion species for charge transfer ionization:
      dimension izH(NcxH1),ijH(NcxH1),izHe(NcxHe1),ijHe(NcxHe1)
      data izH   /6, 7, 8,12,14,16,26, 0/
     #     ijH   /1, 1, 1, 2, 2, 1, 2, 0/
      data izHe  /6, 7,14,14,16,18, 26, 0/
     #     ijHe  /2, 2, 2, 3, 3, 2,  3, 0/
      data izero/num*0/
C
 900  format(a)
      cx = .false.
      cf = .false.
      if (icflag .eq. 1 .or. icflag .eq. 3) cf = .true.
      if (icflag .eq. 2 .or. icflag .eq. 3) cx = .true.
      if (cx) then
        iH(NcxH1) = 0
        iHe(NcxHe1) = 0
      endif

      open(22,file='/home/rsmith/projects/hydro/dat/jr/tables.t',
     #	status='old',readonly)

c..........stuff temperature array

      do 50 it=1,ntemp
	Temp(it) = 4.0 + (it-1.)/10.
 50   continue

c..........fill the index() table

c          select H, He if charge exchange wanted
      if (cx) then
        index(1) = 1
        index(2) = 1
      endif
      ix = 1
      do 60 no=1,num
	ixn = ix + nj(no)
	if (index(no) .ne. 0) then
	  index(no)=ix
	  ix=ixn+1
	end if
 60   continue

c...........Ionization rate table

      do 100 no=1,num1
        call rdone(rion,ntemp,no,nj,index,22)
 100  continue

c...........Recombination rate table

      do 110 no=1,num1
        call rdone(rrec,ntemp,no,nj,index,22)
 110  continue

c...........Cooling rate table (optional)

      do 120 no=1,num1
        if (cf) then
          call rdone(cool,ntemp,no,nj,index,22)
        else
          call rdone(cool,ntemp,no,nj,izero,22)
        end if
 120  continue

c...........Charge Exchange recombination rate tables (optional)

      if (cx) then

        do 130 no=1,num1
          call rdone(cxhr,ntemp1,no,nj,index,22)
 130    continue

        do 140 no=1,num1
          call rdone(cxher,ntemp1,no,nj,index,22)
 140    continue

c.........Charge Exchange ionization rates and index tables

        read(22,900)junk
        read(22,900)junk
        read(22,900)junk
        read(22,*)(Temp(it),(cxhi(it,j),j=1,NcxH),it=1,ntemp1)
        do 200 iHx=1,NcxH
	  do 220 no=1,num1
	    if(izH(iHx).eq.nj(no) .and. index(no).ne.0) then
	      iH(iHx)=index(no)+ijH(iHx)-1
	    end if
 220	  continue
 200    continue
	do 201 it=1,ntemp1
	  do 202 j=1,NcxH
            if (cxhi(it,j) .gt. 1.0e-35) then
	      cxhi(it,j) = log10(cxhi(it,j))
            else
              cxhi(it,j) = -35.
            endif
202	  continue
201	continue

        read(22,900)junk
        read(22,900)junk
        read(22,900)junk
        read(22,*)(Temp(it),(cxhei(it,j),j=1,NcxHe),it=1,ntemp1)
        do 210 iHex=1,NcxHe
	  do 230 no=1,num1
	    if(izHe(iHex).eq.nj(no) .and. index(no).ne.0) then
	      iHe(iHex)=index(no)+ijHe(iHex)-1
	    end if
 230	  continue
 210    continue
	do 211 it=1,ntemp1
	  do 212 j=1,NcxHe
            if (cxhei(it,j) .gt. 1.0e-35) then
	      cxhei(it,j) = log10(cxhei(it,j))
            else
              cxhei(it,j) = -35.
            endif
212	  continue
211	continue

      end if
c.......................end of charge exchange...............

      close(22)

c....................Aluminum..................................
      if (index(14) .gt. 0) then
c	open(22,file='[edgar.tables]alion.dat',
        open(22,file='/home/rsmith/projects/hydro/jr/alion.dat',
     #		status='old',readonly)
	call rdone(rion,ntemp,14,nj,index,22)
	close(22)
c	open(22,file='[edgar.tables]alrec.dat',
	open(22,file='/home/rsmith/projects/hydro/jr/alrec.dat',
     #		status='old',readonly)
	call rdone(rrec,ntemp,14,nj,index,22)
	close(22)

c..................zero the cool and cx tables as appropriate.........

	ix = index(14) - 1
	nz1 = nj(14) + 1
	if (cf) then
	  do 310 nt = 1,ntemp
	    do 310 j = 1,nz1
	      cool(nt,ix+j) = -35.0
 310	  continue
	endif

	if (cx) then
	  do 320 nt = 1,ntemp1
	    do 320 j = 1,nz1
	      cxHr(nt,ix+j) = -35.0
	      cxHer(nt,ix+j) = -35.0
 320	  continue
	endif

      endif

c.....................end of Aluminum.................................
      return
      end

      subroutine rdone(table,ntemp,no,nj,index,lun)
      real table(ntemp,*)
      integer index(*),nj(*)
      dimension Temp(41)
      character*10 junk

900   format (a)
      nz1 = nj(no) + 1
      ix = index(no) - 1
      if (index(no) .gt. 0) then
        do 80 n=1,nz1,10
          n9 = min(n+9,nz1)
          read(lun,900)junk
          read(lun,900)junk
          read(lun,900)junk
          do 80 nt=1,ntemp
            read(lun,*) Temp(nt),(table(nt,ix+j),j=n,n9)
80      continue
c....................take logs of rates......................
        do 85 nt=1,ntemp
          do 84 j=1,nz1
            if (table(nt,ix+j) .gt. 1.0e-35) then
              table(nt,ix+j) = log10(table(nt,ix+j))
            else
              table(nt,ix+j) = -35.
            endif
 84       continue
 85     continue
c.....................skip this table.........................
      else
        do 90 n=1,nz1,10
          read(lun,900)junk
          read(lun,900)junk
          read(lun,900)junk
          do 90 nt=1,ntemp
            read(lun,900)junk
90      continue
      endif
      return
      end
