      subroutine setup_raymond(AbundType,indx)

      implicit none

      include 'jr_common.inc'
      include 'datafiles.inc'
      integer AbundType,indx(NUM),i
      character datafile*128
c     
c  Set the elemental abundances.
c
      call set_abund(Abundtype,abunj)
c
c  Read data files to run Raymond code.
c
      open(UNIT=2,FILE=atomic_data,STATUS='OLD')
      call atread(NUM)
c
c  Set the spectral information
c
      Nbin = 1000
      binmin = 10.
      binsyz = 2.
c
c  Set up index into ion vector
c
      indx(1) = 1
      do i=2,NUM
         indx(i) = indx(i-1)+nj(i-1)+1
      end do

      return
      end

      subroutine set_abund(AbundType,abund)

      implicit none

      include 'datafiles.inc'
      integer NUM
      parameter(NUM=12)
      real abund(NUM),abH
      integer i,AbundType
      
      if (AbundType .EQ. 1) open(unit=10,FILE=ab_anders, STATUS='OLD')
      if (AbundType .EQ. 2) open(unit=10,FILE=ab_depleted, STATUS='OLD')
      if (AbundType .EQ. 3) open(unit=10,FILE=ab_allen, STATUS='OLD')
      if (AbundType .eq. 4) open(unit=10,FILE=ab_grevesse, STATUS='OLD')
      if ((AbundType .LT. 1).OR.(AbundType .GT. 4)) then
         write(*,*) 'set_abund: Error, AbundType out of range.'
         stop
      end if

      read(10,*) abH
      do i = 1,NUM
         read(10,*) abund(i)
      end do
      close(10)
      
      return
      end

