      subroutine setup_raymond

      implicit none

      include 'jr_common.inc'
      include 'datafiles.inc'
      integer AbundType,indx(NUM)
      integer i, k, index
      integer atom, ion_states, stage, ix, iy, iy3

c
c     Elements are: He,C ,N ,O ,Ne,Mg,Si,S ,Ar,Ca,Fe,Ni
c
      data indx/1 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,1/
c     
c  Set the elemental abundances to Anders & Grevesse
c
      Abundtype = 1 
      call set_abund(Abundtype,abunj)
c
c  Read data files to run Raymond code.
c
      open(UNIT=2,FILE=atomic_data,STATUS='OLD')
      call atread(NUM)
c
c  Set the spectral information
c
      Nbin = 1000
      binmin = 10.
      binsyz = 2.
c
c  Set up index into ion vector
c
      indx(1) = 1
      do i=2,NUM
         indx(i) = indx(i-1)+nj(i-1)+1
      end do
c
c  Sort out the line information to start
c
      numlines = 0
      do atom=1,num
        ion_states = nj(atom)+1
        ix = 0
        do stage=1,ion_states
          iy = llj(atom,stage)
          iy3 = 3*iy
          do k = 1,iy3
            index = ix+k
            if (wj(atom,index) .ne. 0.0) then
               numlines = numlines + 1
               atom_index(numlines) = atom
               ion_index(numlines)  = stage
               line_index(numlines) = index
            end if
         end do
         ix = ix + iy3
       end do
      end do

      return
      end

      subroutine setup_bin(inNbin, inbinmin, inbinsyz) 

      implicit none

      include 'jr_common.inc'
      
      integer inNbin
      real inbinmin, inbinsyz

      Nbin = inNbin
      binmin = inbinmin
      binsyz = inbinsyz

      return
      end
      
      subroutine set_abund(AbundType,abund)

      implicit none

      include 'datafiles.inc'
      integer NUM
      parameter(NUM=12)
      real abund(NUM),abH
      integer i,AbundType
      
      if (AbundType .EQ. 1) open(unit=10,FILE=ab_anders, STATUS='OLD')
      if (AbundType .EQ. 2) open(unit=10,FILE=ab_depleted, STATUS='OLD')
      if (AbundType .EQ. 3) open(unit=10,FILE=ab_allen, STATUS='OLD')
      if (AbundType .eq. 4) open(unit=10,FILE=ab_grevesse, STATUS='OLD')
      if ((AbundType .LT. 1).OR.(AbundType .GT. 4)) then
         write(*,*) 'set_abund: Error, AbundType out of range.'
         stop
      end if

      read(10,*) abH
      do i = 1,NUM
         read(10,*) abund(i)
      end do
      close(10)
      
      return
      end

