/** \name ProfitLinkDef.h
    \brief File containing RootCint bindings necessary for profit GUIs. This is an "internal" header.
     Clients should not ever need to use this.
    \author James Peachey

    The Profit software package was developed by Dr. Randall Smith and
    Mr. James Peachey at the High Energy Astrophysics Science Archive
    Research Center (HEASARC) at the Goddard Space Flight Center (GSFC)
    of the National Aeronautics and Space Administration (NASA).
*/
#ifdef __MAKECINT__

#pragma link off all class;
#pragma link off all function;
#pragma link off all global;
#pragma link off all typedef;

#pragma link C++ nestedclass;
#pragma link C++ nestedtypedef;

#pragma link C++ namespace profit;
#pragma link C++ class profit::DataEntryPanel;
#pragma link C++ class profit::DataEntryWidget;
#pragma link C++ class profit::Gui;
#pragma link C++ class profit::SpectrumView;
#pragma link C++ class profit::StripChart;
#pragma link C++ class profit::UnitTestGui;

#endif
